## START: Set by rpmautospec
## (rpmautospec version 0.8.1)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 10;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

# Per upstream recommendations.
# https://www.cryptopp.com/wiki/Link_Time_Optimization
%define _lto_cflags %{nil}

Name:           cryptopp
Version:        8.8.0
Release:        %autorelease
Summary:        C++ class library of cryptographic schemes
# Automatically converted from old format: Boost - review is highly recommended.
License:        BSL-1.0
URL:            https://www.cryptopp.com

%define v_tag %(v=%{version}; echo ${v//./_})
%define v_file %(v=%{version}; echo ${v//./})

Source0:        %{url}/cryptopp%{v_file}.zip
Source1:        %{url}/cryptopp%{v_file}.zip.sig
Source2:        %{url}/signing.html#/keyring.gpg
Source10:       https://github.com/noloader/cryptopp-autotools/releases/download/CRYPTOPP_%{v_tag}/cryptopp-autotools%{v_file}.zip
Source11:       https://github.com/noloader/cryptopp-autotools/releases/download/CRYPTOPP_%{v_tag}/cryptopp-autotools%{v_file}.zip.sig

# Should be <major>+<minor>:<patch>:<minor> (this is confusing -_-)
Patch0:         fix-autotools-version-info.patch

# fix "undefined reference to `AdhocTest'" when linking to the shared object
Patch1:         remove-adhoc.patch

BuildRequires:  bash
BuildRequires:  coreutils
BuildRequires:  findutils
BuildRequires:  glibc-common

BuildRequires:  doxygen

BuildRequires:  gcc
BuildRequires:  gcc-c++

BuildRequires:  make
BuildRequires:  libtool
BuildRequires:  automake

BuildRequires:  dos2unix
BuildRequires:  gnupg2

Obsoletes:  %{name}-progs < 8.8.0-3

# Obsoletes pycryptopp to avoid breaking upgrades
Obsoletes:  pycryptopp < 0.7
Provides:   pycryptopp = 0.7


%description
Crypto++ Library is a free C++ class library of cryptographic schemes.
See http://www.cryptopp.com/ for a list of supported algorithms.

One purpose of Crypto++ is to act as a repository of public domain
(not copyrighted) source code. Although the library is copyrighted as a
compilation, the individual files in it are in the public domain.

%package devel
Summary:        Header files and development documentation for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}
Obsoletes:      %{name}-doc < 8.8.0-3
Provides:       %{name}-doc < 8.8.0-3

%description devel
Crypto++ Library is a free C++ class library of cryptographic schemes.

This package contains the header files and development documentation
for %{name}.

%package static
Summary:        Static libraries for %{name}
Requires:       %{name}-devel%{?_isa} = %{version}-%{release}

%description static
Crypto++ Library is a free C++ class library of cryptographic schemes.

This package contains static libraries for %{name}.

%prep
%{gpgverify} --keyring='%{SOURCE2}' --signature='%{SOURCE1}' --data='%{SOURCE0}'
%{gpgverify} --keyring='%{SOURCE2}' --signature='%{SOURCE11}' --data='%{SOURCE10}'

%autosetup -c -p1 -a 10
find . -type f -name "*.zip" -exec rm "{}" \;
dos2unix License.txt Readme.txt
find . -not -type d -exec file "{}" ";" -print0 | grep -z CRLF | cut -d':' -z -f1 | xargs -0 dos2unix

%build
autoreconf -vi
# Upstream recommends -O3, define NDEBUG to prevent sensitive data leaking on crash
export CXXFLAGS="$(echo "%{optflags}" | sed -e 's/-O2//') -O3 -DNDEBUG"
%configure
%make_build all-am docs

%install
%make_install
rm %{buildroot}%{_bindir}/cryptest
rm -rf %{buildroot}%{_datadir}/%{name}/
mkdir -p %{buildroot}%{_libdir}/pkgconfig
install -p -m 0644 libcryptopp.pc %{buildroot}%{_libdir}/pkgconfig/libcryptopp.pc

%check
./cryptest v

%files
%{_libdir}/libcryptopp.so.8*
%doc Readme.txt
%license License.txt

%files devel
%doc html-docs/*
%{_includedir}/cryptopp
%{_libdir}/libcryptopp.so
%{_libdir}/pkgconfig/libcryptopp.pc

%files static
%{_libdir}/libcryptopp.a

%changelog
## START: Generated by rpmautospec
* Thu Jan 16 2025 Fedora Release Engineering <releng@fedoraproject.org> - 8.8.0-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_42_Mass_Rebuild

* Wed Jul 24 2024 Miroslav Suchý <msuchy@redhat.com> - 8.8.0-9
- convert Boost license to SPDX

* Wed Jul 17 2024 Fedora Release Engineering <releng@fedoraproject.org> - 8.8.0-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_41_Mass_Rebuild

* Wed Jan 24 2024 Fedora Release Engineering <releng@fedoraproject.org> - 8.8.0-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Fri Jan 19 2024 Fedora Release Engineering <releng@fedoraproject.org> - 8.8.0-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Wed Sep 27 2023 Zephyr Lykos <git@mochaa.ws> - 8.8.0-5
- Use gcc-c++ instead of gcc-g++ [skip changelog]

* Tue Sep 26 2023 Zephyr Lykos <git@mochaa.ws> - 8.8.0-4
- Fix shared object versioning and linking

* Tue Sep 26 2023 Zephyr Lykos <fedora@mochaa.ws> - 8.8.0-3
- Use default toolchain since GCC is no longer breaking builds
- Migrate to GNU Autotools build, fix pkg-config file syntax and name
- Verify GPG signature
- Obsolete -doc subpackage, move into -devel
- Obsolete -progs subpackage (only useful during testing)
- Add -static subpackage

* Wed Jul 19 2023 Fedora Release Engineering <releng@fedoraproject.org> - 8.8.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Fri Jun 30 2023 Vasiliy N. Glazov <vascom2@gmail.com> 8.8.0-1
- Update to 8.8.0

* Thu Jan 19 2023 Fedora Release Engineering <releng@fedoraproject.org> - 8.7.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Tue Aug 23 2022 Nicolas Chauvet <kwizart@gmail.com> - 8.7.0-1
- Update to 8.7.0

* Wed Jul 20 2022 Fedora Release Engineering <releng@fedoraproject.org> - 8.6.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Thu Jan 20 2022 Fedora Release Engineering <releng@fedoraproject.org> - 8.6.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Sun Sep 26 2021 Vasiliy N. Glazov <vascom2@gmail.com> 8.6.0-1
- Update to 8.6.0

* Wed Jul 21 2021 Fedora Release Engineering <releng@fedoraproject.org> - 8.4.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Tue Jan 26 2021 Fedora Release Engineering <releng@fedoraproject.org> - 8.4.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Sun Jan 03 2021 Vasiliy N. Glazov <vascom2@gmail.com> 8.4.0-1
- Update to 8.4.0

* Wed Dec 30 2020 Vasiliy N. Glazov <vascom2@gmail.com> 8.3.0-1
- Update to 8.3.0

* Mon Jul 27 2020 Fedora Release Engineering <releng@fedoraproject.org> - 8.2.0-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Tue Jan 28 2020 Fedora Release Engineering <releng@fedoraproject.org> - 8.2.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Wed Jul 24 2019 Fedora Release Engineering <releng@fedoraproject.org> - 8.2.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_31_Mass_Rebuild

* Tue May 21 2019 Vasiliy N. Glazov <vascom2@gmail.com> 8.2.0-1
- Update to 8.2.0

* Thu Feb 28 2019 Nicolas Chauvet <kwizart@gmail.com> - 8.1.0-2
- Improve how to set our flags
- Remove ppc fixup
- Backport patch to fix build

* Tue Feb 26 2019 Nicolas Chauvet <kwizart@gmail.com> - 8.1.0-1
- Update to 8.1.0

* Thu Feb 14 2019 Nicolas Chauvet <kwizart@gmail.com> - 8.0.0-1
- Update to 8.0.0

* Thu Jan 31 2019 Fedora Release Engineering <releng@fedoraproject.org> - 7.0.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Mon Nov 05 2018 Nicolas Chauvet <kwizart@gmail.com> - 7.0.0-2
- Obsoletes pycryptopp

* Sun Aug 05 2018 Nicolas Chauvet <kwizart@gmail.com> - 7.0.0-1
- Update to 7.0.0

* Thu Jul 12 2018 Fedora Release Engineering <releng@fedoraproject.org> - 6.1.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Fri Feb 23 2018 Nicolas Chauvet <kwizart@gmail.com> - 6.1.0-2
- Disable ppc64le war - fixed upstream

* Thu Feb 22 2018 Nicolas Chauvet <kwizart@gmail.com> - 6.1.0-1
- Update to 6.1.0

* Mon Feb 19 2018 Nicolas Chauvet <kwizart@gmail.com> - 6.0.0-1
- Update to 6.0.0

* Mon Feb 19 2018 Nicolas Chauvet <kwizart@gmail.com> - 5.6.5-1
- Update to 5.6.5 (vanilla)

* Wed Feb 07 2018 Fedora Release Engineering <releng@fedoraproject.org> - 5.6.3-11
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Wed Aug 02 2017 Fedora Release Engineering <releng@fedoraproject.org> - 5.6.3-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Binutils_Mass_Rebuild

* Wed Jul 26 2017 Fedora Release Engineering <releng@fedoraproject.org> - 5.6.3-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Sat Apr 01 2017 Petr Šabata <contyk@redhat.com> - 5.6.3-8
- Hitting rhbz#1404466 again; increasing the number of retries to 1024
- There appears to be a better long-term fix available at GH
  weidai11/cryptopp but that approach hasn't been merged upstream yet

* Fri Feb 10 2017 Fedora Release Engineering <releng@fedoraproject.org> - 5.6.3-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Tue Dec 13 2016 Merlin Mathesius <mmathesi@redhat.com> - 5.6.3-6
- Include upstream RDSEED patch to correct FTBFS (BZ#1404466).

* Tue Jul 26 2016 Morten Stevens <mstevens@fedoraproject.org> - 5.6.3-5
- Rebuilt f25/f26 dist tag

* Tue Jul 26 2016 Morten Stevens <mstevens@fedoraproject.org> - 5.6.3-4
- Rebuilt for c++ ABI breakage (#1360441)

* Mon Apr 11 2016 Morten Stevens <mstevens@fedoraproject.org> - 5.6.3-3
- CVE-2016-3995

* Wed Feb 03 2016 Fedora Release Engineering <releng@fedoraproject.org> - 5.6.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Fri Jan 08 2016 Morten Stevens <mstevens@fedoraproject.org> - 5.6.3-1
- Update to 5.6.3

* Sun Nov 08 2015 Morten Stevens <mstevens@fedoraproject.org> - 5.6.2-10
- Remove libdir from pkg-config file #1161960

* Mon Jun 29 2015 Morten Stevens <mstevens@fedoraproject.org> - 5.6.2-9
- CVE-2015-2141

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 5.6.2-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Thu Apr 23 2015 Morten Stevens  <mstevens@fedoraproject.org> - 5.6.2-7
- Rebuilt for yet another C++ ABI break

* Thu Feb 19 2015 Morten Stevens <mstevens@fedoraproject.org> - 5.6.2-6
- GCC 5 rebuilt

* Sat Aug 16 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 5.6.2-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 5.6.2-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 5.6.2-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Thu Apr  4 2013 Alexey Kurov <nucleo@fedoraproject.org> - 5.6.2-2
- cryptopp.pc cleanup

* Wed Apr  3 2013 Alexey Kurov <nucleo@fedoraproject.org> - 5.6.2-1
- Crypto++ 5.6.2
- License: Boost

* Wed Feb 13 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 5.6.1-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Wed Jul 18 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 5.6.1-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Tue Feb 28 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 5.6.1-7
- Rebuilt for c++ ABI breakage

* Thu Jan  5 2012 Alexey Kurov <nucleo@fedoraproject.org> - 5.6.1-6
- fix build with gcc-4.7.0

* Mon Oct 17 2011 Alexey Kurov <nucleo@fedoraproject.org> - 5.6.1-5
- remove includedir in cryptopp.pc (rhbz#732208)

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 5.6.1-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Sun Jan 23 2011 Alexey Kurov <nucleo@fedoraproject.org> - 5.6.1-3
- patch config.h for enable SSE2 only on x86_64

* Thu Oct 21 2010 Alexey Kurov <nucleo@fedoraproject.org> - 5.6.1-2
- add -DCRYPTOPP_DISABLE_SSE2 to CXXFLAGS instead of config.h for non-x86_64 (rhbz#645169)
- install TestVectors and TestData in cryptopp-progs
- patch cryptest for using data files in /usr/share/cryptopp
- build cryptestcwd for build time test only
- fix check section

* Wed Sep  1 2010 Alexey Kurov <nucleo@fedoraproject.org> - 5.6.1-1
- Crypto++ 5.6.1
- fixed pkgconfig file installation
- build cryptopp-doc as noarch subpkg

* Thu Nov 26 2009 Alexey Kurov <nucleo@fedoraproject.org> - 5.6.1-0.1.svn479
- svn r479. MARS placed in the public domain by Wei Dai
- Fixes rhbz#539227

* Fri Oct 30 2009 Rahul Sundaram <sundaram@fedoraproject.org> 5.6.0-5
- Fix source

* Wed Oct 28 2009 Rahul Sundaram <sundaram@fedoraproject.org> 5.6.0-4
- Add pkgconfig file. Fixes rhbz#512761

* Fri Jul 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 5.6.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Tue Jun  9 2009 Dan Horak <dan[at]dannu.cz> 5.6.0-2
- add support for s390/s390x

* Sun Mar 15 2009 Aurelien Bompard <abompard@fedoraproject.org> 5.6.0-1
- version 5.6.0
- rediff patches

* Tue Feb 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 5.5.2-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Tue Sep 30 2008 Aurelien Bompard <abompard@fedoraproject.org> 5.5.2-3
- purge source archive from patented code
- use SSE2 on x86_64
- preserve timestamps on install

* Mon Sep 22 2008 Aurelien Bompard <abompard@fedoraproject.org> 5.5.2-2
- rediff gcc 4.3 patch

* Wed Aug 27 2008 Aurelien Bompard <abompard@fedoraproject.org> 5.5.2-1
- adapt to fedora, from Mandriva

## END: Generated by rpmautospec
